#!/bin/bash

echo '开始构建智能营销平台项目'
export PATH=${PATH}:/usr/local/maven/bin
  buildDeploys=("common/common-core" "common/common-mybatis" "common/common-redis" "system/system-api")
  mvn clean #清空历史数据
  buildDeploy(){
    for ((i=0;i<${#buildDeploys[*]};i++))
    do
      nProject=${buildDeploys[i]}
      echo "开始处理${nProject}"
      cd "${WORKSPACE}"/"${nProject}"
      mvn deploy
    done
    echo "静态依赖处理完毕，准备开始构建服务。。。"
  }
buildDeploy
cd "${WORKSPACE}"
mvn install

kubectl delete deployment ism-auth-service -n ism-service
kubectl delete deployment ism-gateway-service -n ism-service
kubectl delete deployment ism-system-user-service -n ism-service


docker images | grep -E "(ism)" | awk '{print $3}' | uniq | xargs -I {} docker rmi --force {}
echo "服务构建完毕，开始打包docker镜像..."
docker login -u admin -p Hg123harbor localhost:9999
echo "==================auth镜像==================="
docker build -t localhost:9999/ism/ism-auth-service:latest -f auth-service/DOCKERFILE .
docker push localhost:9999/ism/ism-auth-service:latest
echo "==================gateway镜像==================="
docker build -t localhost:9999/ism/ism-gateway-service:latest -f gateway-service/DOCKERFILE .
docker push localhost:9999/ism/ism-gateway-service:latest
echo "==================system-user-service镜像==================="
docker build -t localhost:9999/ism/ism-system-user-service:latest -f system/system-user-service/DOCKERFILE .
docker push localhost:9999/ism/ism-system-user-service:latest
echo "docker镜像上传完毕,智能营销平台项目构建完毕"
echo "清理缓存。。。"
mvn clean
echo "开始部署k8s服务..."
echo "===========auth-service=============="
kubectl create -f ./auth-service/deployment.yaml
echo "===========gateway-service=============="
kubectl create -f ./gateway-service/deployment.yaml
echo "===========user-service=============="
kubectl create -f ./system/system-user-service/deployment.yaml


